// Veoh.js

function Veoh_CheckURL( url, option )
{
//	if(url.match( /^http:\/\/(\w+\.)?veoh\.com\/videos\/(.*?)/ )) {
		return 1;
//	} else {
//		return 0;
//	}
}

/*
 Get a YouTube URL
*/
function Veoh_GetURL( url, option )
{
	var video_url = url;
	return video_url;
}

/*
 Video search
 
 keyword     : keyword to search
 start_index : starting index (based on 1)
 length      : number of videos to search for
 option      : The current search criteria, defaults to 0 (?)
 
 Return info
 
 .keyword                            : search string
 .total                              : total number of results
                                                -1 : error
                                                 0 : no results
                                                 >0: total results
 .start                              : starting number (based on 1)
 .end                                : ending number (based on 1)
 .VideoInfo                          : video sequence information
 .VideoInfo[n].Author                : Author (string)
 .VideoInfo[n].Title                 : Title (string)
 .VideoInfo[n].LengthSeconds         : LengthSeconds: total video playback time (in seconds) (integer)
 .VideoInfo[n].RatingAvg             : RatingAvg: rating (float)
 .VideoInfo[n].RatingCount           : RatingCount: number of votes (integer)
 .VideoInfo[n].Description           : Description (string)
 .VideoInfo[n].ViewCount             : ViewCount (integer)
 .VideoInfo[n].UploadTime            : UploadTime: Video upload time (UNIX style)
 .VideoInfo[n].CommentCount          : CommentCount (integer)
 .VideoInfo[n].MylistCount           : MylistCount: ? (integer)
 .VideoInfo[n].Tags                  : Tags: Space-delimited string of tags, e.g. "tag1 tag2 tag3"
 .VideoInfo[n].URL                   : URL: Link to viewing page (string)
 .VideoInfo[n].ThumbnailURL          : ThumbnailURL: URL to thumbnail (string)
 .VideoInfo[n].SaveFilename          : SaveFilename (string)
                                                "Movie deprecated set unique ID please."
 .VideoInfo [n]. Attr: Integer OR video attribute set to the following value
                                                 1: read-only (not delete)
                                                 2: download
                                                 4: Play is a need to connect to the network
                                                 Usually, 1 +2 +4, 7
                                                 MS is a directory, so one can not be removed
                                                 MS files, 0
 .VideoInfo[n].child				 : children
 .VideoInfo[n].parent				 : parents
*/
function Veoh_Search( keyword, start_index, length, option )
{
	var pattern = /<video((.|\r|\n)*?)\/video>/;
	var result = new Object();
    result.keyword   = keyword;		// Search
	result.VideoInfo = new Array();	// Results in sequence
	result.start     = start_index;	// Index of first result
	result.end       = 0;
	result.total     = -1;

	var query = keyword.replace( /\s/g, "+");
	// API calls for searching
	var url_base = "http://www.veoh.com/rest/v2/execute.xml?method=veoh.search.search&type=video&tag=" + query +"&apiKey=33329B06-1A46-C265-8A85-6AA2F31734CE&offset=" + String(start_index-1) + "&maxResults="+length;

	var nPage = Math.floor( (start_index - 1) / 10 ) + 1;	/* begin the search page */
	var nIndex = (nPage - 1) * 10 + 1;						/* begin index */
	while(nIndex < (start_index + length)) {
		var url = url_base;
		var contents = GetContents( url );
		if(contents == null) { return null; /* failed to get page */ }
		/* total number of results */
		var i = nIndex;
		if(contents.match( /\sitems\=\"(.*?)\"/ )) {
			result.total = RegExp.$1 - 0;
		}
		while(contents.indexOf("<video") >= 0) {
//		while(pattern.exec( contents ) != null) {
			if((start_index <= i) && (i < (start_index + length))) {
				var r = 0;
				contents = contents.substring(contents.indexOf("<video"));
				var e_end = contents.indexOf("/video>");
				var item = contents.substring(0, e_end+7);
				contents = contents.substring(item.length);
//				var item = RegExp.$1;	// <entry>～</entry> video information
				info = new Object();

				// Title
				if(item.match( /\stitle\=\"(.*?)\"/ )) {
					info.Title = RegExp.$1;
					info.SaveFilename = RegExp.$1;
				}
				// Description
				if(item.match( /\sdescription\=\"(.*?)\"/ )) {
					info.Description = RegExp.$1;
				}
				// Thumbnail
				if(item.match( /\sfullMedResImagePath\=\"(.*?)\"/ )) {
					info.ThumbnailURL = RegExp.$1;
				} else { r=1; }
				// URL
				if(item.match( /\sfullPreviewHashPath\=\"(.*?)\"/ )) {
					info.URL = RegExp.$1;
				} else { r=1; }
				// view count
				if(item.match( /\snumViews\=\"(.*?)\"/ )) {
					info.ViewCount = RegExp.$1 - 0;
				}
				// Length
				if(item.match( /\slength\=\"(.*?)\"/ )) {
					time = RegExp.$1;
					if(time.match( /(.*?) hr (.*?) min/ )) {
						var t_hr = RegExp.$1 - 0;
						var t_min = RegExp.$2 - 0;
						var t_sec = 0;
					} else if(time.match( /(.*?) min (.*?) sec/ )) {
						var t_hr = 0;
						var t_min = RegExp.$1 - 0;
						var t_sec = RegExp.$2 - 0;
					} else if (time.match( /(.*?) sec/ )) {
						var t_hr = 0;
						var t_min = 0;
						var t_sec = RegExp.$1 - 0;
					}
					var timeSec = (t_hr * 3600) + (t_min * 60) + t_sec;
					info.LengthSeconds = timeSec;
				}
				// Rating / rating count
				if(item.match( /\srating\=\"(.*?)\"\snumRatingVotes\=\"(.*?)\"/ )) {
					info.RatingAvg = RegExp.$1 - 0;
					info.RatingCount = RegExp.$2 - 0;
				}
				info.attr = 7;
				if(r == 0) {result.VideoInfo.push( info );}
			}
			i++;
		}
		nIndex = nIndex + 10;
		nPage++;
	}
	if(result.VideoInfo.length) {
		result.end   = result.start + (result.VideoInfo.length - 1);
	} else {
		result.total = 0;	// no results.
	}
	return result;
}

// Service metadata
var Veoh = new Object();
Veoh.Name          = "Veoh";			/* Service name */
Veoh.Description   = "Veoh";			/* Service description */
Veoh.SearchDesc    = "Veoh";			/* Service search screen description */
Veoh.SearchOSKMode = 1;						/* OSK mode 1: English only  2: Japanese */
Veoh.CheckURL      = Veoh_CheckURL;	/* CheckURL function */
Veoh.GetURL        = Veoh_GetURL;		/* GetURL function */
Veoh.Search        = Veoh_Search;		/* Search function */

// add Veoh to site list
SiteList.push( Veoh );
